// aChgSndCfg.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define WAVE_DEVICE_FILE				L"WAV1:"
#define SET_FRONT_SPEAKER_CONTROL_CODE	0x001D01A0
#define GET_FRONT_SPEAKER_CONTROL_CODE	0x001D01A4

#define OPTION_STRING_YES		L"yes"
#define OPTION_STRING_ON		L"on"
#define OPTION_STRING_NO		L"no"
#define OPTION_STRING_OFF		L"off"
#define OPTION_STRING_TOGGLE	L"toggle"

BOOL
SetFrontSpeaker(
	int		iOn
)
{
	BOOL	bRet = FALSE;
	HANDLE	hDevice = INVALID_HANDLE_VALUE;

	hDevice = CreateFile(WAVE_DEVICE_FILE, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if (hDevice != INVALID_HANDLE_VALUE) {
		DWORD	dwVal;
		DWORD	dwBytesReturned;

		dwVal = iOn;
		bRet = DeviceIoControl(hDevice, SET_FRONT_SPEAKER_CONTROL_CODE, NULL, 0, &dwVal, sizeof(dwVal), &dwBytesReturned, NULL);

		CloseHandle(hDevice);
		hDevice = NULL;
	}

	return bRet;
}

int
GetFrontSpeaker(
)
{
	int		iRet = -1;
	HANDLE	hDevice = INVALID_HANDLE_VALUE;

	hDevice = CreateFile(WAVE_DEVICE_FILE, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if (hDevice != INVALID_HANDLE_VALUE) {
		BOOL	bRet;
		DWORD	dwVal;
		DWORD	dwBytesReturned;

		bRet = DeviceIoControl(hDevice, GET_FRONT_SPEAKER_CONTROL_CODE, NULL, 0, &dwVal, sizeof(dwVal), &dwBytesReturned, NULL);

		CloseHandle(hDevice);
		hDevice = NULL;

		if (bRet) {
			iRet = dwVal;
		}
	}

	return iRet;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	int		iOn = 0;

	if (lpCmdLine != NULL && (wcscmp(lpCmdLine, OPTION_STRING_YES) == 0 || wcscmp(lpCmdLine, OPTION_STRING_ON) == 0) ) {
		iOn = 1;
	}
	else if (lpCmdLine != NULL && (wcscmp(lpCmdLine, OPTION_STRING_NO) == 0 || wcscmp(lpCmdLine, OPTION_STRING_OFF) == 0) ) {
		iOn = 0;
	}
	else if (lpCmdLine != NULL && wcscmp(lpCmdLine, OPTION_STRING_TOGGLE) == 0) {
		int iCurrentVal;

		iCurrentVal = GetFrontSpeaker();
		switch(iCurrentVal) {
		case 0:
			iOn = 1;
			break;
		case 1:
			iOn = 0;
			break;
		default:
			iOn = 0;
			break;
		}
	}
	else {
		int iRet;

		iRet = MessageBox(	NULL,
							L"Xs[J[؂ւ܂\r\n[͂] : OʃXs[J[\r\n[] : wʃXs[J[",
							L"aChgSndCfg",
							MB_ICONQUESTION|MB_YESNO );
		if (iRet == IDYES) {
			iOn = 1;
		}
		else {
			iOn = 0;
		}
	}

	SetFrontSpeaker(iOn);

	return 0;
}

